#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <libp.h>

extern FREELIST *_mallocchains[MEMCHAINS];

void free(void *buf)
{
	FREELIST *p, **c;
	int size;
	if (!buf)
		return;
	p = buf;
	size = *--((size_t *)p);
	c = &_mallocchains[(size>>2) % MEMCHAINS];
	p->next = *c;
	p->size = size + sizeof(size_t);
	(*c) = p;
}