.c.o:
	cc68k -I..\stdinc $(CFLAGS) $*
	as68k -V68020/68881 $*
	mkliblst $(LIBLIST) .o $&

.c.obj:
	cc386 -I..\stdinc -C+N $(CFLAGS) $*
	@nasm -fobj $*.asm
	mkliblst $(LIBLIST) .obj $&

.src.o:
	as68k  /V68000/68881 $*
	mkliblst $(LIBLIST) .o $&

.asm.obj:
	@tasm /ml /m2 $*
	mkliblst $(LIBLIST) .obj $&
.nas.obj:
	@nasm -fobj $&
	mkliblst $(LIBLIST) .obj $&

!ifdef i386
ASM_TAG = obj
LIBLIST = ..\object\lib386.lst
!else
ASM_TAG = o
LIBLIST = ..\object\lib68k.lst
!endif

.path.src = 68k
.path.asm = 386

all: $(C_DEPENDENCIES) $(ASM_DEPENDENCIES)
     move *.$(ASM_TAG) ..\object
!ifndef i386
     del *.SRC
!else
     del *.asm
!endif